diff --git a/drivers/base/power/generic_ops.c b/drivers/base/power/generic_ops.c
index 5ee030a..b8d31f6 100644
--- a/drivers/base/power/generic_ops.c
+++ b/drivers/base/power/generic_ops.c
@@ -93,6 +93,49 @@ int pm_generic_suspend_late(struct device *dev)
 EXPORT_SYMBOL_GPL(pm_generic_suspend_late);
 
 /**
+ * pm_generic_suspend_late_runtime - Generic suspend_late callback for
+ * subsystems that wants to use runtime_suspend callbacks at suspend_late.
+ * @dev: Device to suspend.
+ */
+int pm_generic_suspend_late_runtime(struct device *dev)
+{
+	int (*callback)(struct device *);
+	int ret = 0;
+
+	/*
+	 * PM core has disabled runtime PM in device_suspend_late, thus we can
+	 * safely check the device's runtime status and decide whether
+	 * additional actions are needed to put the device into low power state.
+	 * If so, we invoke the device's runtime_suspend callback.
+	 * For the !CONFIG_PM_RUNTIME case, pm_runtime_status_suspended() always
+	 * returns false and therefore the runtime_suspend callback will be
+	 * invoked.
+	 */
+	if (pm_runtime_status_suspended(dev))
+		return 0;
+
+	if (dev->pm_domain)
+		callback = dev->pm_domain->ops.runtime_suspend;
+	else if (dev->type && dev->type->pm)
+		callback = dev->type->pm->runtime_suspend;
+	else if (dev->class && dev->class->pm)
+		callback = dev->class->pm->runtime_suspend;
+	else if (dev->bus && dev->bus->pm)
+		callback = dev->bus->pm->runtime_suspend;
+	else
+		callback = NULL;
+
+	if (!callback && dev->driver && dev->driver->pm)
+		callback = dev->driver->pm->runtime_suspend;
+
+	if (callback)
+		ret = callback(dev);
+
+	return ret;
+}
+EXPORT_SYMBOL_GPL(pm_generic_suspend_late_runtime);
+
+/**
  * pm_generic_suspend - Generic suspend callback for subsystems.
  * @dev: Device to suspend.
  */
@@ -129,6 +172,17 @@ int pm_generic_freeze_late(struct device *dev)
 EXPORT_SYMBOL_GPL(pm_generic_freeze_late);
 
 /**
+ * pm_generic_freeze_late_runtime - Generic freeze_late callback for
+ * subsystems that wants to use runtime_suspend callbacks at freeze_late.
+ * @dev: Device to freeze.
+ */
+int pm_generic_freeze_late_runtime(struct device *dev)
+{
+	return pm_generic_suspend_late_runtime(dev);
+}
+EXPORT_SYMBOL_GPL(pm_generic_freeze_late_runtime);
+
+/**
  * pm_generic_freeze - Generic freeze callback for subsystems.
  * @dev: Device to freeze.
  */
@@ -165,6 +219,17 @@ int pm_generic_poweroff_late(struct device *dev)
 EXPORT_SYMBOL_GPL(pm_generic_poweroff_late);
 
 /**
+ * pm_generic_poweroff_late_runtime - Generic poweroff_late callback for
+ * subsystems that wants to use runtime_suspend callbacks at poweroff_late.
+ * @dev: Device to handle.
+ */
+int pm_generic_poweroff_late_runtime(struct device *dev)
+{
+	return pm_generic_suspend_late_runtime(dev);
+}
+EXPORT_SYMBOL_GPL(pm_generic_poweroff_late_runtime);
+
+/**
  * pm_generic_poweroff - Generic poweroff callback for subsystems.
  * @dev: Device to handle.
  */
@@ -201,6 +266,17 @@ int pm_generic_thaw_early(struct device *dev)
 EXPORT_SYMBOL_GPL(pm_generic_thaw_early);
 
 /**
+ * pm_generic_thaw_early_runtime - Generic thaw_early callback for subsystems
+ * that wants to use runtime_resume callbacks at thaw_early.
+ * @dev: Device to thaw.
+ */
+int pm_generic_thaw_early_runtime(struct device *dev)
+{
+	return pm_generic_resume_early_runtime(dev);
+}
+EXPORT_SYMBOL_GPL(pm_generic_thaw_early_runtime);
+
+/**
  * pm_generic_thaw - Generic thaw callback for subsystems.
  * @dev: Device to thaw.
  */
@@ -237,6 +313,49 @@ int pm_generic_resume_early(struct device *dev)
 EXPORT_SYMBOL_GPL(pm_generic_resume_early);
 
 /**
+ * pm_generic_resume_early_runtime - Generic resume_early callback for
+ * subsystems that wants to use runtime_resume callbacks at resume_early.
+ * @dev: Device to resume.
+ */
+int pm_generic_resume_early_runtime(struct device *dev)
+{
+	int (*callback)(struct device *);
+	int ret = 0;
+
+	/*
+	 * PM core has not yet enabled runtime PM in device_resume_early,
+	 * thus we can safely check the device's runtime status and restore the
+	 * previous state we had in device_suspend_late. If restore is needed
+	 * we invoke the device's runtime_resume callback.
+	 * For the !CONFIG_PM_RUNTIME case, pm_runtime_status_suspended() always
+	 * returns false and therefore the runtime_resume callback will be
+	 * invoked.
+	 */
+	if (pm_runtime_status_suspended(dev))
+		return 0;
+
+	if (dev->pm_domain)
+		callback = dev->pm_domain->ops.runtime_resume;
+	else if (dev->type && dev->type->pm)
+		callback = dev->type->pm->runtime_resume;
+	else if (dev->class && dev->class->pm)
+		callback = dev->class->pm->runtime_resume;
+	else if (dev->bus && dev->bus->pm)
+		callback = dev->bus->pm->runtime_resume;
+	else
+		callback = NULL;
+
+	if (!callback && dev->driver && dev->driver->pm)
+		callback = dev->driver->pm->runtime_resume;
+
+	if (callback)
+		ret = callback(dev);
+
+	return ret;
+}
+EXPORT_SYMBOL_GPL(pm_generic_resume_early_runtime);
+
+/**
  * pm_generic_resume - Generic resume callback for subsystems.
  * @dev: Device to resume.
  */
@@ -273,6 +392,17 @@ int pm_generic_restore_early(struct device *dev)
 EXPORT_SYMBOL_GPL(pm_generic_restore_early);
 
 /**
+ * pm_generic_restore_early_runtime - Generic restore_early callback for
+ * subsystems that wants to use runtime_resume callbacks at restore_early.
+ * @dev: Device to restore
+ */
+int pm_generic_restore_early_runtime(struct device *dev)
+{
+	return pm_generic_resume_early_runtime(dev);
+}
+EXPORT_SYMBOL_GPL(pm_generic_restore_early_runtime);
+
+/**
  * pm_generic_restore - Generic restore callback for subsystems.
  * @dev: Device to restore.
  */
diff --git a/include/linux/pm.h b/include/linux/pm.h
index a224c7f..c7c2db7 100644
--- a/include/linux/pm.h
+++ b/include/linux/pm.h
@@ -656,22 +656,28 @@ extern void dpm_for_each_dev(void *data, void (*fn)(struct device *, void *));
 
 extern int pm_generic_prepare(struct device *dev);
 extern int pm_generic_suspend_late(struct device *dev);
+extern int pm_generic_suspend_late_runtime(struct device *dev);
 extern int pm_generic_suspend_noirq(struct device *dev);
 extern int pm_generic_suspend(struct device *dev);
 extern int pm_generic_resume_early(struct device *dev);
+extern int pm_generic_resume_early_runtime(struct device *dev);
 extern int pm_generic_resume_noirq(struct device *dev);
 extern int pm_generic_resume(struct device *dev);
 extern int pm_generic_freeze_noirq(struct device *dev);
 extern int pm_generic_freeze_late(struct device *dev);
+extern int pm_generic_freeze_late_runtime(struct device *dev);
 extern int pm_generic_freeze(struct device *dev);
 extern int pm_generic_thaw_noirq(struct device *dev);
 extern int pm_generic_thaw_early(struct device *dev);
+extern int pm_generic_thaw_early_runtime(struct device *dev);
 extern int pm_generic_thaw(struct device *dev);
 extern int pm_generic_restore_noirq(struct device *dev);
 extern int pm_generic_restore_early(struct device *dev);
+extern int pm_generic_restore_early_runtime(struct device *dev);
 extern int pm_generic_restore(struct device *dev);
 extern int pm_generic_poweroff_noirq(struct device *dev);
 extern int pm_generic_poweroff_late(struct device *dev);
+extern int pm_generic_poweroff_late_runtime(struct device *dev);
 extern int pm_generic_poweroff(struct device *dev);
 extern void pm_generic_complete(struct device *dev);
 